Index: /LMDZ6/trunk/libf/phylmdiso/thermcell_main.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/thermcell_main.F90	(revision 4088)
+++ /LMDZ6/trunk/libf/phylmdiso/thermcell_main.F90	(revision 4089)
@@ -1,6 +1,6 @@
-!
+
 ! $Id: thermcell_main.F90 3451 2019-01-27 11:07:30Z fhourdin $
 !
-      SUBROUTINE thermcell_main(itap,ngrid,nlay,ptimestep  &
+      subroutine thermcell_main(itap,ngrid,nlay,ptimestep  &
      &                  ,pplay,pplev,pphi,debut  &
      &                  ,pu,pv,pt,po  &
@@ -8,16 +8,7 @@
      &                  ,fm0,entr0,detr0,zqta,zqla,lmax  &
      &                  ,ratqscth,ratqsdiff,zqsatth  &
-     &                  ,Ale_bl,Alp_bl,lalim_conv,wght_th &
      &                  ,zmax0, f0,zw2,fraca,ztv &
-     &                  ,zpspsk,ztla,zthl &
-!!! nrlmd le 10/04/2012
-     &                  ,pbl_tke,pctsrf,omega,airephy &
-     &                  ,zlcl,fraca0,w0,w_conv,therm_tke_max0,env_tke_max0 &
-     &                  ,n2,s2,ale_bl_stat &
-     &                  ,therm_tke_max,env_tke_max &
-     &                  ,alp_bl_det,alp_bl_fluct_m,alp_bl_fluct_tke &
-     &                  ,alp_bl_conv,alp_bl_stat &
-!!! fin nrlmd le 10/04/2012
-     &                  ,ztva & 
+     &                  ,zpspsk,ztla,zthl,ztva &
+     &                  ,pcon,rhobarz,wth3,wmax_sec,lalim,fm,alim_star,zmax &
 #ifdef ISO         
      &      ,xtpo,xtpdoadj &
@@ -25,8 +16,9 @@
      &   )
 
-      USE dimphy
-      USE ioipsl
-      USE indice_sol_mod
-      USE print_control_mod, ONLY: lunout,prt_level
+
+      USE thermcell_ini_mod, ONLY: thermcell_ini,dqimpl,dvdq,prt_level,lunout,prt_level
+      USE thermcell_ini_mod, ONLY: iflag_thermals_closure,iflag_thermals_ed,tau_thermals,r_aspect_thermals
+      USE thermcell_ini_mod, ONLY: RD,RG
+
 #ifdef ISO
   USE infotrac_phy, ONLY : ntraciso
@@ -37,4 +29,6 @@
 #endif
 #endif
+
+
       IMPLICIT NONE
 
@@ -74,35 +68,29 @@
 !   -------------
 
-#include "YOMCST.h"
-#include "YOETHF.h"
-#include "FCTTRE.h"
-#include "thermcell.h"
 
 !   arguments:
 !   ----------
-
-!IM 140508
-      INTEGER itap
-
-      INTEGER ngrid,nlay
-      real ptimestep
-      REAL pt(ngrid,nlay),pdtadj(ngrid,nlay)
-      REAL pu(ngrid,nlay),pduadj(ngrid,nlay)
-      REAL pv(ngrid,nlay),pdvadj(ngrid,nlay)
-      REAL po(ngrid,nlay),pdoadj(ngrid,nlay)
-      REAL pplay(ngrid,nlay),pplev(ngrid,nlay+1)
-      real pphi(ngrid,nlay)
-      LOGICAL debut
+      integer, intent(in) :: itap,ngrid,nlay
+      real, intent(in) ::  ptimestep
+      real, intent(in), dimension(ngrid,nlay)    :: pt,pu,pv,po,pplay,pphi,zpspsk
+      real, intent(in), dimension(ngrid,nlay+1)  :: pplev
+      real, intent(out), dimension(ngrid,nlay)   :: pdtadj,pduadj,pdvadj,pdoadj,entr0,detr0
+      real, intent(out), dimension(ngrid,nlay)   :: ztla,zqla,zqta,zqsatth,zthl
+      real, intent(out), dimension(ngrid,nlay+1) :: fm0,zw2,fraca
+      real, intent(out), dimension(ngrid) :: zmax0,f0
+      real, intent(out), dimension(ngrid,nlay) :: ztva,ztv
+      logical, intent(in) :: debut
+
+      real, intent(out), dimension(ngrid) :: pcon
+      real, intent(out), dimension(ngrid,nlay) :: rhobarz,wth3
+      real, intent(out), dimension(ngrid) :: wmax_sec
+      integer,intent(out), dimension(ngrid) :: lalim
+      real, intent(out), dimension(ngrid,nlay+1) :: fm
+      real, intent(out), dimension(ngrid,nlay) :: alim_star
+      real, intent(out), dimension(ngrid) :: zmax
 
 !   local:
 !   ------
 
-      integer icount
-
-      integer, save :: dvdq=1,dqimpl=-1
-!$OMP THREADPRIVATE(dvdq,dqimpl)
-      data icount/0/
-      save icount
-!$OMP THREADPRIVATE(icount)
 
       integer,save :: igout=1
@@ -113,159 +101,33 @@
 !$OMP THREADPRIVATE(lev_out)
 
-      REAL susqr2pi, Reuler
-
-      INTEGER ig,k,l,ll,ierr
-      real zsortie1d(klon)
-      INTEGER lmax(klon),lmin(klon),lalim(klon)
-      INTEGER lmix(klon)
-      INTEGER lmix_bis(klon)
-      real linter(klon)
-      real zmix(klon)
-      real zmax(klon),zw2(klon,klev+1),ztva(klon,klev),zw_est(klon,klev+1),ztva_est(klon,klev)
-!      real fraca(klon,klev)
-
-      real zmax_sec(klon)
-!on garde le zmax du pas de temps precedent
-      real zmax0(klon)
-!FH/IM     save zmax0
-
-      real lambda
-
-      real zlev(klon,klev+1),zlay(klon,klev)
-      real deltaz(klon,klev)
-      REAL zh(klon,klev)
-      real zthl(klon,klev),zdthladj(klon,klev)
-      REAL ztv(klon,klev)
-      real zu(klon,klev),zv(klon,klev),zo(klon,klev)
-      real zl(klon,klev)
-      real zsortie(klon,klev)
-      real zva(klon,klev)
-      real zua(klon,klev)
-      real zoa(klon,klev)
-
-      real zta(klon,klev)
-      real zha(klon,klev)
-      real fraca(klon,klev+1)
-      real zf,zf2
-      real thetath2(klon,klev),wth2(klon,klev),wth3(klon,klev)
-      real q2(klon,klev)
-! FH probleme de dimensionnement avec l'allocation dynamique
-!     common/comtherm/thetath2,wth2
-      real wq(klon,klev)
-      real wthl(klon,klev)
-      real wthv(klon,klev)
-    
-      real ratqscth(klon,klev)
-      real var
-      real vardiff
-      real ratqsdiff(klon,klev)
-
+      real lambda, zf,zf2,var,vardiff,CHI
+      integer ig,k,l,ierr,ll
       logical sorties
-      real rho(klon,klev),rhobarz(klon,klev),masse(klon,klev)
-      real zpspsk(klon,klev)
-
-      real wmax(klon)
-      real wmax_tmp(klon)
-      real wmax_sec(klon)
-      real fm0(klon,klev+1),entr0(klon,klev),detr0(klon,klev)
-      real fm(klon,klev+1),entr(klon,klev),detr(klon,klev)
-
-      real ztla(klon,klev),zqla(klon,klev),zqta(klon,klev)
-!niveau de condensation
-      integer nivcon(klon)
-      real zcon(klon)
-      REAL CHI
-      real zcon2(klon)
-      real pcon(klon)
-      real zqsat(klon,klev)
-      real zqsatth(klon,klev) 
-
-      real f_star(klon,klev+1),entr_star(klon,klev)
-      real detr_star(klon,klev)
-      real alim_star_tot(klon)
-      real alim_star(klon,klev)
-      real alim_star_clos(klon,klev)
-      real f(klon), f0(klon)
-!FH/IM     save f0
-      real zlevinter(klon)
-       real seuil
-      real csc(klon,klev)
-
-!!! nrlmd le 10/04/2012
-
-!------Entrées
-      real pbl_tke(klon,klev+1,nbsrf)
-      real pctsrf(klon,nbsrf)
-      real omega(klon,klev)
-      real airephy(klon)
-!------Sorties
-      real zlcl(klon),fraca0(klon),w0(klon),w_conv(klon)
-      real therm_tke_max0(klon),env_tke_max0(klon)
-      real n2(klon),s2(klon)
-      real ale_bl_stat(klon)
-      real therm_tke_max(klon,klev),env_tke_max(klon,klev)
-      real alp_bl_det(klon),alp_bl_fluct_m(klon),alp_bl_fluct_tke(klon),alp_bl_conv(klon),alp_bl_stat(klon)
-!------Local
-      integer nsrf
-      real rhobarz0(klon)                    ! Densité au LCL
-      logical ok_lcl(klon)                   ! Existence du LCL des thermiques
-      integer klcl(klon)                     ! Niveau du LCL
-      real interp(klon)                      ! Coef d'interpolation pour le LCL
-!--Triggering
-      real Su                                ! Surface unité: celle d'un updraft élémentaire
-      parameter(Su=4e4)
-      real hcoef                             ! Coefficient directeur pour le calcul de s2
-      parameter(hcoef=1)
-      real hmincoef                          ! Coefficient directeur pour l'ordonnée à l'origine pour le calcul de s2 
-      parameter(hmincoef=0.3)
-      real eps1                              ! Fraction de surface occupée par la population 1 : eps1=n1*s1/(fraca0*Sd)
-      parameter(eps1=0.3)
-      real hmin(ngrid)                       ! Ordonnée à l'origine pour le calcul de s2
-      real zmax_moy(ngrid)                   ! Hauteur moyenne des thermiques : zmax_moy = zlcl + 0.33 (zmax-zlcl)
-      real zmax_moy_coef
-      parameter(zmax_moy_coef=0.33)
-      real depth(klon)                       ! Epaisseur moyenne du cumulus
-      real w_max(klon)                       ! Vitesse max statistique 
-      real s_max(klon)
-!--Closure
-      real pbl_tke_max(klon,klev)            ! Profil de TKE moyenne 
-      real pbl_tke_max0(klon)                ! TKE moyenne au LCL
-      real w_ls(klon,klev)                   ! Vitesse verticale grande échelle (m/s)
-      real coef_m                            ! On considère un rendement pour alp_bl_fluct_m
-      parameter(coef_m=1.)
-      real coef_tke                          ! On considère un rendement pour alp_bl_fluct_tke
-      parameter(coef_tke=1.)
-
-!!! fin nrlmd le 10/04/2012
-
-!
-      !nouvelles variables pour la convection
-      real Ale_bl(klon)
-      real Alp_bl(klon)
-      real alp_int(klon),dp_int(klon),zdp
-      real ale_int(klon)
-      integer n_int(klon)
-      real fm_tot(klon)
-      real wght_th(klon,klev)
-      integer lalim_conv(klon)
-!v1d     logical therm
-!v1d     save therm
-
-      character*2 str2
-      character*10 str10
+      real, dimension(ngrid) :: linter,zmix, zmax_sec
+      integer,dimension(ngrid) :: lmax,lmin,lmix,lmix_bis,nivcon
+      real, dimension(ngrid,nlay) :: ztva_est
+      real, dimension(ngrid,nlay) :: deltaz,zlay,zh,zdthladj,zu,zv,zo,zl,zva,zua,zoa
+      real, dimension(ngrid,nlay) :: zta,zha,q2,wq,wthl,wthv,thetath2,wth2
+      real, dimension(ngrid,nlay) :: ratqscth,ratqsdiff,rho,masse
+      real, dimension(ngrid,nlay+1) :: zw_est,zlev
+      real, dimension(ngrid) :: wmax,wmax_tmp
+      real, dimension(ngrid,nlay+1) :: f_star
+      real, dimension(ngrid,nlay) :: entr,detr,entr_star,detr_star,alim_star_clos
+      real, dimension(ngrid,nlay) :: zqsat,csc
+      real, dimension(ngrid) :: zcon,zcon2,alim_star_tot,f
 
       character (len=20) :: modname='thermcell_main'
       character (len=80) :: abort_message
 
-      EXTERNAL SCOPY
 
 #ifdef ISO
       REAL xtpo(ntraciso,ngrid,nlay),xtpdoadj(ntraciso,ngrid,nlay)
-      REAL xtzo(ntraciso,klon,klev)
+      REAL xtzo(ntraciso,ngrid,nlay)
       REAL xtpdoadj_tmp(ngrid,nlay)
-      REAL xtpo_tmp(klon,klev)
-      REAL xtzo_tmp(klon,klev)
+      REAL xtpo_tmp(ngrid,nlay)
+      REAL xtzo_tmp(ngrid,nlay)
       integer ixt
 #endif
+
 !
 
@@ -274,43 +136,21 @@
 !   ---------------
 !
-
-   seuil=0.25
-
-   if (debut) then
-      if (iflag_thermals==15.or.iflag_thermals==16) then
-         dvdq=0
-         dqimpl=-1
-      else
-         dvdq=1
-         dqimpl=1
-      endif
-
-      fm0=0.
-      entr0=0.
-      detr0=0.
-   endif
+    print*,'NEW THERMCELL cool'
+
+
    fm=0. ; entr=0. ; detr=0.
-   icount=icount+1
-
-!IM 090508 beg
-!print*,'====================================================================='
-!print*,'====================================================================='
-!print*,' PAS ',icount,' PAS ',icount,' PAS ',icount,' PAS ',icount
-!print*,'====================================================================='
-!print*,'====================================================================='
-!IM 090508 end
 
       if (prt_level.ge.1) print*,'thermcell_main V4'
 
        sorties=.true.
-      IF(ngrid.NE.klon) THEN
+      IF(ngrid.NE.ngrid) THEN
          PRINT*
          PRINT*,'STOP dans convadj'
          PRINT*,'ngrid    =',ngrid
-         PRINT*,'klon  =',klon
+         PRINT*,'ngrid  =',ngrid
       ENDIF
 !
 !     write(lunout,*)'WARNING thermcell_main f0=max(f0,1.e-2)'
-     do ig=1,klon
+     do ig=1,ngrid
          f0(ig)=max(f0(ig),1.e-2)
          zmax0(ig)=max(zmax0(ig),40.)
@@ -357,34 +197,26 @@
          zlev(:,l)=0.5*(pphi(:,l)+pphi(:,l-1))/RG
       enddo
-         zlev(:,1)=0.
-         zlev(:,nlay+1)=(2.*pphi(:,klev)-pphi(:,klev-1))/RG
+      zlev(:,1)=0.
+      zlev(:,nlay+1)=(2.*pphi(:,nlay)-pphi(:,nlay-1))/RG
       do l=1,nlay
          zlay(:,l)=pphi(:,l)/RG
       enddo
-!calcul de l epaisseur des couches
       do l=1,nlay
          deltaz(:,l)=zlev(:,l+1)-zlev(:,l)
       enddo
 
-!     print*,'2 OK convect8'
 !-----------------------------------------------------------------------
-!   Calcul des densites
+!   Calcul des densites et masses
 !-----------------------------------------------------------------------
 
-     rho(:,:)=pplay(:,:)/(zpspsk(:,:)*RD*ztv(:,:))
-
-     if (prt_level.ge.10)write(lunout,*)                                &
-    &    'WARNING thermcell_main rhobarz(:,1)=rho(:,1)'
+      rho(:,:)=pplay(:,:)/(zpspsk(:,:)*RD*ztv(:,:))
+      if (prt_level.ge.10) write(lunout,*) 'WARNING thermcell_main rhobarz(:,1)=rho(:,1)'
       rhobarz(:,1)=rho(:,1)
-
       do l=2,nlay
          rhobarz(:,l)=0.5*(rho(:,l)+rho(:,l-1))
       enddo
-
-!calcul de la masse
       do l=1,nlay
          masse(:,l)=(pplev(:,l)-pplev(:,l+1))/RG
       enddo
-
       if (prt_level.ge.1) print*,'thermcell_main apres initialisation'
 
@@ -501,6 +333,6 @@
       if (prt_level.ge.1) print*,'apres thermcell_plume ',lev_out
 
-      call test_ltherm(ngrid,nlay,pplev,pplay,lalim,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_plum lalim ')
-      call test_ltherm(ngrid,nlay,pplev,pplay,lmix ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_plum lmix  ')
+      call test_ltherm(ngrid,nlay,pplay,lalim,ztv,po,ztva,zqla,f_star,zw2,'thermcell_plum lalim ')
+      call test_ltherm(ngrid,nlay,pplay,lmix ,ztv,po,ztva,zqla,f_star,zw2,'thermcell_plum lmix  ')
 
       if (prt_level.ge.1) print*,'thermcell_main apres thermcell_plume'
@@ -530,8 +362,8 @@
 
 
-      call test_ltherm(ngrid,nlay,pplev,pplay,lalim,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lalim ')
-      call test_ltherm(ngrid,nlay,pplev,pplay,lmin ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmin  ')
-      call test_ltherm(ngrid,nlay,pplev,pplay,lmix ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmix  ')
-      call test_ltherm(ngrid,nlay,pplev,pplay,lmax ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmax  ')
+      call test_ltherm(ngrid,nlay,pplay,lalim,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lalim ')
+      call test_ltherm(ngrid,nlay,pplay,lmin ,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmin  ')
+      call test_ltherm(ngrid,nlay,pplay,lmix ,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmix  ')
+      call test_ltherm(ngrid,nlay,pplay,lmax ,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmax  ')
 
       if (prt_level.ge.1) print*,'thermcell_main apres thermcell_height'
@@ -547,6 +379,6 @@
 
  
-call test_ltherm(ngrid,nlay,pplev,pplay,lmin,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_dry  lmin  ')
-call test_ltherm(ngrid,nlay,pplev,pplay,lalim,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_dry  lalim ')
+call test_ltherm(ngrid,nlay,pplay,lmin,ztv,po,ztva,zqla,f_star,zw2,'thermcell_dry  lmin  ')
+call test_ltherm(ngrid,nlay,pplay,lalim,ztv,po,ztva,zqla,f_star,zw2,'thermcell_dry  lalim ')
 
       if (prt_level.ge.1) print*,'thermcell_main apres thermcell_dry'
@@ -603,5 +435,4 @@
 !-------------------------------------------------------------------------------
 !deduction des flux
-!-------------------------------------------------------------------------------
 
       CALL thermcell_flux2(ngrid,nlay,ptimestep,masse, &
@@ -612,6 +443,6 @@
 
       if (prt_level.ge.1) print*,'thermcell_main apres thermcell_flux'
-      call test_ltherm(ngrid,nlay,pplev,pplay,lalim,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_flux lalim ')
-      call test_ltherm(ngrid,nlay,pplev,pplay,lmax ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_flux lmax  ')
+      call test_ltherm(ngrid,nlay,pplay,lalim,ztv,po,ztva,zqla,f_star,zw2,'thermcell_flux lalim ')
+      call test_ltherm(ngrid,nlay,pplay,lmax ,ztv,po,ztva,zqla,f_star,zw2,'thermcell_flux lmax  ')
 
 !------------------------------------------------------------------
@@ -640,4 +471,5 @@
       call thermcell_dq(ngrid,nlay,dqimpl,ptimestep,fm0,entr0,masse,  &
      &                   po,pdoadj,zoa,lev_out)
+
 #ifdef ISO
         ! C Risi: on utilise directement la même routine
@@ -675,17 +507,19 @@
         enddo
       enddo !DO  ll=1,nlay 
-      write(*,*) 'thermcell_main 600 tmp: apres thermcell_dq' 
+      write(*,*) 'thermcell_main 600 tmp: apres thermcell_dq'
 #endif      
 #endif
 
+
+
 !------------------------------------------------------------------
 ! Calcul de la fraction de l'ascendance
 !------------------------------------------------------------------
-      do ig=1,klon
+      do ig=1,ngrid
          fraca(ig,1)=0.
          fraca(ig,nlay+1)=0.
       enddo
       do l=2,nlay
-         do ig=1,klon
+         do ig=1,ngrid
             if (zw2(ig,l).gt.1.e-10) then
             fraca(ig,l)=fm(ig,l)/(rhobarz(ig,l)*zw2(ig,l))
@@ -819,25 +653,4 @@
          enddo
       enddo
-!
-! $Id: thermcell_main.F90 3451 2019-01-27 11:07:30Z fhourdin $
-!
-      CALL thermcell_alp(ngrid,nlay,ptimestep  &
-     &                  ,pplay,pplev  &
-     &                  ,fm0,entr0,lmax  &
-     &                  ,Ale_bl,Alp_bl,lalim_conv,wght_th &
-     &                  ,zw2,fraca &
-!!! necessire en plus
-     &                  ,pcon,rhobarz,wth3,wmax_sec,lalim,fm,alim_star,zmax &
-!!! nrlmd le 10/04/2012
-     &                  ,pbl_tke,pctsrf,omega,airephy &
-     &                  ,zlcl,fraca0,w0,w_conv,therm_tke_max0,env_tke_max0 &
-     &                  ,n2,s2,ale_bl_stat &
-     &                  ,therm_tke_max,env_tke_max &
-     &                  ,alp_bl_det,alp_bl_fluct_m,alp_bl_fluct_tke &
-     &                  ,alp_bl_conv,alp_bl_stat &
-!!! fin nrlmd le 10/04/2012
-     &                   )
-
-
 
 !calcul du ratqscdiff
@@ -847,5 +660,5 @@
       ratqsdiff(:,:)=0.
 
-      do l=1,klev
+      do l=1,nlay
          do ig=1,ngrid
             if (l<=lalim(ig)) then
@@ -857,5 +670,5 @@
       if (prt_level.ge.1) print*,'14f OK convect8'
 
-      do l=1,klev
+      do l=1,nlay
          do ig=1,ngrid
             if (l<=lalim(ig)) then
@@ -868,15 +681,9 @@
 
       if (prt_level.ge.1) print*,'14g OK convect8'
-      do l=1,nlay
-         do ig=1,ngrid
-            ratqsdiff(ig,l)=sqrt(vardiff)/(po(ig,l)*1000.)   
-!           write(11,*)'ratqsdiff=',ratqsdiff(ig,l)
-         enddo
-      enddo 
-!--------------------------------------------------------------------    
-!
-!ecriture des fichiers sortie
-!     print*,'15 OK convect8 CCCCCCCCCCCCCCCCCCc'
-
+         do l=1,nlay
+            do ig=1,ngrid
+               ratqsdiff(ig,l)=sqrt(vardiff)/(po(ig,l)*1000.)   
+            enddo
+         enddo 
       endif
 
@@ -884,23 +691,22 @@
 
       return
-      end
-
-!-----------------------------------------------------------------------------
-
-      subroutine test_ltherm(klon,klev,pplev,pplay,long,seuil,ztv,po,ztva,zqla,f_star,zw2,comment)
-      USE print_control_mod, ONLY: prt_level
+      end subroutine thermcell_main
+
+!=============================================================================
+!/////////////////////////////////////////////////////////////////////////////
+!=============================================================================
+      subroutine test_ltherm(ngrid,nlay,pplay,long,ztv,po,ztva, &  ! in
+    &            zqla,f_star,zw2,comment)                          ! in
+!=============================================================================
+      USE thermcell_ini_mod, ONLY: prt_level
       IMPLICIT NONE
 
-      integer i, k, klon,klev
-      real pplev(klon,klev+1),pplay(klon,klev)
-      real ztv(klon,klev)
-      real po(klon,klev)
-      real ztva(klon,klev)
-      real zqla(klon,klev)
-      real f_star(klon,klev)
-      real zw2(klon,klev)
-      integer long(klon)
+      integer i, k, ngrid,nlay
+      real, intent(in), dimension(ngrid,nlay) :: pplay,ztv,po,ztva,zqla
+      real, intent(in), dimension(ngrid,nlay) :: f_star,zw2
+      integer, intent(in), dimension(ngrid) :: long
       real seuil
       character*21 comment
+      seuil=0.25
 
       if (prt_level.ge.1) THEN
@@ -910,10 +716,10 @@
 
 !  test sur la hauteur des thermiques ...
-         do i=1,klon
+         do i=1,ngrid
 !IMtemp           if (pplay(i,long(i)).lt.seuil*pplev(i,1)) then
            if (prt_level.ge.10) then
                print*,'WARNING ',comment,' au point ',i,' K= ',long(i)
                print*,'  K  P(MB)  THV(K)     Qenv(g/kg)THVA        QLA(g/kg)   F*        W2'
-               do k=1,klev
+               do k=1,nlay
                   write(6,'(i3,7f10.3)') k,pplay(i,k),ztv(i,k),1000*po(i,k),ztva(i,k),1000*zqla(i,k),f_star(i,k),zw2(i,k)
                enddo
@@ -925,10 +731,16 @@
       end
 
-!!! nrlmd le 10/04/2012                          Transport de la TKE par le thermique moyen pour la fermeture en ALP 
-!                                                         On transporte pbl_tke pour donner therm_tke
-!                                          Copie conforme de la subroutine DTKE dans physiq.F écrite par Frederic Hourdin
-      subroutine thermcell_tke_transport(ngrid,nlay,ptimestep,fm0,entr0,  &
-     &           rg,pplev,therm_tke_max)
-      USE print_control_mod, ONLY: prt_level
+! nrlmd le 10/04/2012   Transport de la TKE par le thermique moyen pour la fermeture en ALP 
+!                       On transporte pbl_tke pour donner therm_tke
+!                       Copie conforme de la subroutine DTKE dans physiq.F écrite par Frederic Hourdin
+
+!=======================================================================
+!///////////////////////////////////////////////////////////////////////
+!=======================================================================
+
+      subroutine thermcell_tke_transport( &
+     &     ngrid,nlay,ptimestep,fm0,entr0,rg,pplev,  &   ! in
+     &     therm_tke_max)                                ! out
+      USE thermcell_ini_mod, ONLY: prt_level
       implicit none
 
@@ -941,13 +753,14 @@
 !=======================================================================
 
-      integer ngrid,nlay,nsrf
-
-      real ptimestep
-      real masse0(ngrid,nlay),fm0(ngrid,nlay+1),pplev(ngrid,nlay+1)
-      real entr0(ngrid,nlay),rg
-      real therm_tke_max(ngrid,nlay)
+      integer ngrid,nlay
+
+      real, intent(in) :: ptimestep
+      real, intent(in), dimension(ngrid,nlay+1) :: fm0,pplev
+      real, intent(in), dimension(ngrid,nlay) :: entr0
+      real, intent(in) :: rg
+      real, intent(out), dimension(ngrid,nlay) :: therm_tke_max
+
       real detr0(ngrid,nlay)
-
-
+      real masse0(ngrid,nlay)
       real masse(ngrid,nlay),fm(ngrid,nlay+1)
       real entr(ngrid,nlay)
@@ -956,9 +769,5 @@
 
       real qa(ngrid,nlay),detr(ngrid,nlay),wqd(ngrid,nlay+1)
-
-      real zzm
-
       integer ig,k
-      integer isrf
 
 
@@ -988,14 +797,5 @@
       fm(:,nlay+1)=0.
 
-!!! nrlmd le 16/09/2010
-!   calcul de la valeur dans les ascendances
-!       do ig=1,ngrid
-!          qa(ig,1)=q(ig,1)
-!       enddo
-!!! 
-
-!do isrf=1,nsrf
-
-!   q(:,:)=therm_tke(:,:,isrf)
+
    q(:,:)=therm_tke_max(:,:)
 !!! nrlmd le 16/09/2010
